;EZUSB, Test 3, using two Data Pointers
#include 8051.h


OUTA .equ   7F96h
OUTB .equ   7F97h
OUTC .equ   7F98h
PINSA .equ  7F99h
PINSB .equ  7F9Ah
PINSC .equ  7F9Bh
OEA  .equ   7F9Ch
OEB  .equ   7F9Dh
OEC  .equ   7F9Eh
dps  .equ   86h
EP2OUT   .equ 7DC0h
EP2IN    .equ 7E00h
EP2INCS  .equ 7FB8h
EP2INBC  .equ 7FB9h
EP2OUTCS .equ 7FC8h
EP2OUTBC .equ 7FC9h


start mov SP,#40h ; set stack

initPortA
      mov DPTR,#0200h
      movx a,@DPTR
      mov DPTR,#OEA
      movx @DPTR,A
initPortB
      mov DPTR,#0201h
      movx a,@DPTR
      mov DPTR,#OEB
      movx @DPTR,A
initPortC
      mov DPTR,#0202h
      movx a,@DPTR
      mov DPTR,#OEC
      movx @DPTR,A

      mov dptr,#EP2IN ; fill EP2IN buffer PINSA to PINSC
      inc dps
      mov dptr,#PINSA
      mov r7,#3
fill  movx a,@dptr
      inc dptr
      inc dps
      movx @dptr,a
      inc dptr
      inc dps
      djnz r7,fill
      ;
      mov dptr,#EP2INBC
      mov a,#4h
      movx @dptr,a ; arm the IN2 transfer
      ;
loop  mov dptr,#EP2INCS ; Control & Status reg
      movx a,@dptr
      jnb ACC.1,serviceIN2 ; not busy, service it
      mov dptr,#EP2OUTCS
      movx a,@dptr
      jb ACC.1,loop ; busy-keep looping
      ;
serviceOUT2
      mov dptr,#OUTA
      inc dps
      mov dptr,#EP2OUT ; fill OUTA to OUTC with EP2OUT buffer 
      mov r7,#3
fill2 movx a,@dptr
      inc dptr
      inc dps
      movx @dptr,a
      inc dptr
      inc dps
      djnz r7,fill2
      inc r2 ; OUT packet counter
      mov a,#4h
      mov dptr,#EP2OUTBC
      movx @dptr,a ; load bc=3 to re-arm OUT2
      sjmp loop
      ;
serviceIN2
      mov dptr,#EP2IN ; fill EP2IN buffer PINSA to PINSC
      inc dps
      mov dptr,#PINSA
      mov r7,#3
fill3 movx a,@dptr
      inc dptr
      inc dps
      movx @dptr,a
      inc dptr
      inc dps
      djnz r7,fill3
      mov dptr,#EP2INBC
      mov a,#4h
      movx @dptr,a ; load bc=3 to re-arm IN2
      sjmp loop

.end
 