unit EZUSB3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Ausgaben: TButton;
    PortInit: TButton;
    Start: TButton;
    Reset: TButton;
    procedure AusgabenClick(Sender: TObject);
    procedure PortInitClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure ResetClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
type _ANCHOR_DOWNLOAD_CONTROL = record
   Offset: Word;
end;

type _VENDOR_REQUEST_IN = record
    bRequest : Byte;
    wValue : Word;
    wIndex : Word;
    wLength: Word;
    direction : Byte;
    bData : Byte;
end;


procedure TForm1.PortInitClick(Sender: TObject);
var TemplateHandle: THandle;
    DeviceHandle: THandle;
    bresult: Boolean;
    nBytes: DWord;
    downloadControl: _ANCHOR_DOWNLOAD_CONTROL;  //mit Startadresse
    Puffer:Array [1..15]of Byte; {Beliebig viele mit ANCHOR-DOWNLOAD}
begin
  Puffer[1]:=$90;   // mov DPTR,$7F9E
  Puffer[2]:=$7F;
  Puffer[3]:=$9E;
  Puffer[4]:=$74;    // mov A,#FF
  Puffer[5]:=$FF;
  Puffer[6]:=$F0;    // mov A,@DPTR
  Puffer[7]:=$90;    // mov DPTR,$7F98
  Puffer[8]:=$7F;
  Puffer[9]:=$98;
  Puffer[10]:=$74;   // mov A,$00
  Puffer[11]:=$00;   // Ausgabebyte an Adr. 000A
  Puffer[12]:=$F0;   // mov @DPTR,A
  Puffer[13]:=$02;   // LJMP $0009
  Puffer[14]:=$00;
  Puffer[15]:=$09;
  downloadControl.offset:=0;
  DeviceHandle := CreateFile ('\\.\ezusb-0',Generic_write,File_Share_write,nil,open_existing,0,TemplateHandle);
  bResult := DeviceIoControl(DeviceHandle,$0022206D,@downloadControl,sizeof(downloadControl),@Puffer,sizeof(Puffer),nBytes,nil);
  CloseHandle (DeviceHandle);
end;

procedure TForm1.StartClick(Sender: TObject);
var TemplateHandle: THandle;
    DeviceHandle: THandle;
    bresult: Boolean;
    nBytes: DWord;
    MyRequest: _VENDOR_REQUEST_IN;
begin
   myRequest.bRequest := $A0;
   myRequest.wValue := $7F92;
   myRequest.wIndex := 0;
   myRequest.wLength := 1;
   myRequest.direction := 0;
   myRequest.bData := 0;     {Reset=0}
   DeviceHandle := CreateFile ('\\.\ezusb-0',Generic_write,File_Share_write,nil,open_existing,0,TemplateHandle);
   bResult := DeviceIoControl(DeviceHandle,$00222014,@myRequest,10,nil,0,nBytes,nil);
   CloseHandle (DeviceHandle);
end;

procedure TForm1.ResetClick(Sender: TObject);
var TemplateHandle: THandle;
    DeviceHandle: THandle;
    bresult: Boolean;
    nBytes: DWord;
    MyRequest: _VENDOR_REQUEST_IN;
begin
   myRequest.bRequest := $A0;
   myRequest.wValue := $7F92;
   myRequest.wIndex := 0;
   myRequest.wLength := 1;
   myRequest.direction := 0;
   myRequest.bData := 1;     {Reset=1}
   DeviceHandle := CreateFile ('\\.\ezusb-0',Generic_write,File_Share_write,nil,open_existing,0,TemplateHandle);
   bResult := DeviceIoControl(DeviceHandle,$00222014,@myRequest,10,nil,0,nBytes,nil);
   CloseHandle (DeviceHandle);
end;

procedure TForm1.AusgabenClick(Sender: TObject);
var TemplateHandle: THandle;
    DeviceHandle: THandle;    bresult: Boolean;
    nBytes: DWord;
    MyRequest: _VENDOR_REQUEST_IN;
    Puffer:Array [1..1024]of Byte;
    n: Integer;
begin
   myRequest.bRequest := $A0;
   myRequest.wValue := $000A;    //Startadresse
   myRequest.wIndex := 0;        //nicht gebraucht
   myRequest.wLength := $01;     //max. 1024
   myRequest.direction := 0;     //Schreiben
   myRequest.bData := $00;    { wenn Length=1 dann setzt der Treiber dieses als Daten ein.}

  //Verwendet IOCTRL_ezusb_Vendor_Request  00222014
  //Geht nur fr Ausgabe eines Einzelbyte
  //oder zum Auslesen von Datenbereichen
  //aber nicht zum Download von Blcken (wrde 01234.. ersetzen)

  DeviceHandle := CreateFile ('\\.\ezusb-0',Generic_write,File_Share_write,nil,open_existing,0,TemplateHandle);
  for n:= 0 to 255 do begin
    myRequest.bData := n;
    bResult := DeviceIoControl(DeviceHandle,$00222014,@myRequest,10,nil,0,nBytes,nil);
  end;
  CloseHandle (DeviceHandle);
end;

end.
