unit EZUSB1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
type USHORT = WORD;

type _USB_DEVICE_DESCRIPTOR = record
    bLength: UCHAR;
    bDescriptorType: UCHAR;
    bcdUSB: WORD;
    bDeviceClass: UCHAR;
    bDeviceSubClass: UCHAR;
    bDeviceProtocol: UCHAR;
    bMaxPacketSize0: UCHAR;
    idVendor: WORD;
    idProduct: WORD;
    bcdDevice: WORD;
    iManufacturer: UCHAR;
    iProduct: UCHAR;
    iSerialNumber: UCHAR;
    bNumConfigurations: UCHAR;
end;

procedure TForm1.Button1Click(Sender: TObject);
var TemplateHandle: THandle;
    bresult: Boolean;
    nBytes: DWord;
    PnBytes: ^DWord;
    DeviceHandle: THandle;
    USB_DEVICE_DESCRIPTOR: _USB_DEVICE_DESCRIPTOR;

begin
  PnBytes := @nBytes;
  DeviceHandle := CreateFile ('\\.\ezusb-0',Generic_write,File_Share_write,nil,open_existing,0,TemplateHandle);
  bResult := DeviceIoControl(DeviceHandle,$00222004,nil,0,@USB_DEVICE_DESCRIPTOR,18,nBytes,nil);
  Edit1.Text := 'VID: ' + FloatToStr (USB_DEVICE_DESCRIPTOR.idVendor);
  Edit2.Text := 'PID: ' + FloatToStr (USB_DEVICE_DESCRIPTOR.idProduct);
  CloseHandle (DeviceHandle);
end;

end.
