VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "TLC1543"
   ClientHeight    =   4185
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4200
   FillColor       =   &H00E0E0E0&
   ForeColor       =   &H8000000B&
   LinkTopic       =   "Form1"
   ScaleHeight     =   4185
   ScaleWidth      =   4200
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame5 
      Caption         =   "Analog D"
      Height          =   615
      Left            =   600
      TabIndex        =   11
      Top             =   3240
      Width           =   1335
      Begin VB.Label Label2 
         Caption         =   "Label2"
         Height          =   255
         Left            =   360
         TabIndex        =   12
         Top             =   240
         Width           =   975
      End
   End
   Begin VB.Frame Frame4 
      Caption         =   "Din"
      Height          =   615
      Left            =   2640
      TabIndex        =   8
      Top             =   1440
      Width           =   1335
      Begin VB.Label Label10 
         Caption         =   "Label10"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "Analog C"
      Height          =   615
      Left            =   600
      TabIndex        =   7
      Top             =   2400
      Width           =   1335
      Begin VB.Label Label9 
         Caption         =   "Label9"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Analog B"
      Height          =   615
      Left            =   600
      TabIndex        =   5
      Top             =   1560
      Width           =   1335
      Begin VB.Label Label8 
         Caption         =   "Label8"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   240
         Width           =   615
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Analog A"
      Height          =   615
      Left            =   600
      TabIndex        =   3
      Top             =   720
      Width           =   1455
      Begin VB.Label Label7 
         Caption         =   "Label7"
         Height          =   255
         Left            =   360
         TabIndex        =   4
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   840
      Max             =   255
      TabIndex        =   0
      Top             =   240
      Width           =   2055
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   3600
      Top             =   720
   End
   Begin VB.Label Label4 
      Caption         =   "0"
      Height          =   255
      Left            =   3120
      TabIndex        =   2
      Top             =   240
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Dout"
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   240
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim sFileName As String
Dim htemp As Long
Dim lIn As Long, lInSize As Long, lOut As Long, lOutSize As Long, lSize As Long
Dim lTemp As Long
Sub USB_IO()
  sFileName = "\\.\Thermometer_0"
  hgDrvrHnd = CreateFile(sFileName, GENERIC_WRITE Or GENERIC_READ, FILE_SHARE_WRITE Or FILE_SHARE_READ, Security, OPEN_EXISTING, 0, 0)
  lTemp = DeviceIoControl(hgDrvrHnd, 4&, lIn, lInSize, lOut, lOutSize, lSize, gOverlapped)
  htemp = CloseHandle(hgDrvrHnd)

End Sub
Sub Brightness(Level)
  lIn = Level * 256 + 14
  lInSize = 2
  lOutSize = 1
  USB_IO
End Sub
Function RdPort(Port) As Integer
  lIn = Port * 256 + 20
  lInSize = 2
  lOutSize = 2
  USB_IO
  RdPort = (lOut / 256) And 255
End Function
Function RdRAM(Adr) As Integer
  lIn = Adr * 256 + 22
  lInSize = 2
  lOutSize = 2
  USB_IO
  RdRAM = (lOut / 256) And 255
End Function
Sub WrRAM(Adresse, Wert)
  lIn = 65536 * Wert + Adresse * 256 + 23
  lInSize = 3
  lOutSize = 1
  USB_IO
End Sub
Private Sub HScroll1_Change()
  Wert = HScroll1.Value
  WrRAM 46, Wert
  Label4.Caption = Str$(Wert)
End Sub
Private Sub HScroll2_Change()
  WrRAM 47, HScroll2.Value
  Label5.Caption = HScroll2.Value
End Sub

Private Sub HScroll3_Change()
  Brightness HScroll3.Value
  Label6 = HScroll3.Value
End Sub


Private Sub Timer1_Timer()
  WrRAM &H34, 0
  Din = RdRAM(&H37)
  Label10.Caption = Str$(Din)
  u1 = 4 * RdRAM(&H7A) + (RdRAM(&H7C) And 15)
  Label7.Caption = Str$(u1)
  u2 = 4 * RdRAM(&H7B) + RdRAM(&H7C) \ 16
  Label8.Caption = Str$(u2)
  u3 = 4 * RdRAM(&H7D) + (RdRAM(&H7F) And 15)
  Label9.Caption = Str$(u3)
  u4 = 4 * RdRAM(&H7E) + RdRAM(&H7F) \ 16
  Label2.Caption = Str$(u4)
  'Label9.Caption = Str$(RdPort(0))
  'Label10.Caption = Str$((RdPort(1)) And 15)
End Sub

