;I2EEwr_1.asm
;Read EEPROM 24C00
;I2C-Adr 1FDh
;Adr/Dat 1FEh,1FFh/200h

#include 8051.h
OEA  .equ   7F9Ch
OEB  .equ   7F9Dh
OEC  .equ   7F9Eh
PINSA .equ  7F99h
PINSB .equ  7F9Ah
PINSC .equ  7F9Bh
OUTA .equ   7F96h
OUTB .equ   7F97h
OUTC .equ   7F98h
I2CS  .equ  7FA5h
I2DAT .equ  7FA6h
START .equ  80h
STOP  .equ  40h
LASTRD .equ 20h
ACK   .equ  02h
DONE  .equ  01h
DPS  .equ   86h

I2COut
     mov   DPTR,#I2CS
     mov   a,#START
     movx  @DPTR,a
     mov   DPTR,#01FDh ;I2C write address
     movx  a,@DPTR    
     mov   DPTR,#I2DAT
     movx  @DPTR,a
     lcall Ready
     mov   DPTR,#01FFh
     movx  a,@DPTR     ;start address Low
     mov   DPTR,#I2DAT
     movx  @DPTR,a     ;write 
     lcall Ready
     mov   DPTR,#0200h
     movx  a,@DPTR     ;data
     mov   DPTR,#I2DAT
     movx  @DPTR,a     ;write data
     lcall Ready
     mov   DPTR,#I2CS
     mov   a,#STOP
     movx  @DPTR,a
     lcall Ready
End  sjmp  End

Ready
     mov   DPTR,#I2CS
     movx  a,@DPTR
     anl   a,#DONE
     cjne  a,#DONE,Ready 
     ret

.End
